
var util = require('util');
util.log('Starting');

// store connections
var BasicConnections= require('./gaminaModule/BasicConnections.js')
var connections = new BasicConnections();

//ws - http://static.brandedcode.com/nws-docs
var ws = require('websocket-server');
var server = ws.createServer();
connections.init(server);


function onConnection (connection) {
    util.log('connection'+connection.id);
    connections.add(connection.id,connection);

    connection.addListener('message',onMessage);
}

function onMessage(msg) {
    console.log('msg'+msg+this.id);
    connections.handleMsg(this.id,msg);
    //test
    var tst = new Object();
    tst['a']='b';
    connections.sendTo(this.id,tst)
}


server.addListener('connection',onConnection);
server.listen(8787);
console.log('Listening WS on 8787');
// end WS



