package ex.videoP2P.logic {
	import ex.videoP2P.SelfVideoWig;

	import org.gamina.api.ITraitsBus;
	import org.gamina.api.IWidget;
	import org.gamina.api.logic.ITrait;
	import org.gamina.srv.AbstractP2PGroup;

	public class ReceiveGuestStreams extends AbstractP2PGroup implements ITrait {
		// https://github.com/OpenRTMFP/Cumulus
		private static const DEVKEY : String = '714e12fee6c4dc50154f8204-a114141a8df6';
		private var particapants : Vector.<String>;
		private var _wig : SelfVideoWig

		public function ReceiveGuestStreams(bus_ : ITraitsBus) {
			_bus = bus_
		}

		public function initTrait(wig_ : IWidget) : ITrait {
			particapants = new Vector.<String>();

			_wig = SelfVideoWig(wig_);
			// temp, it should be a widget of many vids
			_wig.width = 1280 / 4;
			_wig.height = 720 / 4;
			_wig.x = _bus.stageReference.stageWidth - 1280 / 4;

			var pub : SelfVidPublish = SelfVidPublish(_bus.getTrait('pub'));
			var guid : String = pub.streamGUID;
			subToStreamGUID(guid);

			_nc.connect(P2P_INTRO_SRV + DEVKEY);
			// dis onPeer
			return this;
		}

		override protected function onPeer() : void {
			// this needs error handling
			_netSCh.play(particapants[0]);
			_wig.attachNetStream(_netSCh);
		}

		public function subToStreamGUID(guestGuid : String) : void {
			particapants.push(guestGuid);
		}

		public function get traitId() : String {
			return null;
		}
	}
}