//S&M, huh, huh
// State- machine-like using strategy

var signal=require('signals');

var BasicSMStrategy = module.exports = function() {}


BasicSMStrategy.prototype.setInitialState=function(args){
    this._state = new Object();
    this._stateChangedSignal = new signal.Signal();
}

BasicSMStrategy.prototype.setState=function(traitId,key,value){
    this._state[traitId+':'+key]=value;
    this._stateChangedSignal.dispatch(traitId,key,value);
}

BasicSMStrategy.prototype.getStateChangeSignal=function() {
    return this._stateChangedSignal;
}

BasicSMStrategy.prototype.getCurrentState=function(traitId,key){
     return this._state[traitId+':'+key];
}



